
/**
 * This implements a half adder circuit
 * 
 * @author kent archie
 * @version 11/18/2003
 */
public class halfAdder
{
    private int sum;  // the sum resulting from the compute method
    private int carry; // the carry, either 1 or 0

    /**
     * Constructor for objects of class halfAdder
     */
    public halfAdder()
    {
        sum = carry = 0;
    }

    /**  return the current sum value */
    public int getSum() { return sum; }
    
    /**  return the current carry value */
    public int getCarry() { return carry; }
    
    /**
     * not() - can't use  the ! operatotr so we need this
     * @param x The integer to be notted
     * @return 0 if x is 1, 1 if x is 0
     */
    private static int not(int x)
    {
        if(x == 0) return 1;
        return 0;
    } // not

    /**
  * compute the single bit addition of the two arguments
  *
  * @param  a   one of the two bits to add
  * @param  b   one of the two bits to add
  * @return     nothing
  */
 public void compute(int a, int b)
 {
     int x1 = not(a)  & b;    // not a and b
     int x2 = a & not(b);     // a and not b

     carry = a & b; // This is the carry
     sum = x1 | x2; // This is the sum
 } // compute
 
}  // class halfAdder
